Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# GT2005StrategySymbols Class Reference

The Xabsl2 symbols that are defined in "strategy-symbols.xml". More...

`#include <GT2005StrategySymbols.h>`

Inheritance diagram for GT2005StrategySymbols:

[legend]
Collaboration diagram for GT2005StrategySymbols:

[legend]
List of all members.

## Input symbols
double | getRobotNumber ()
double | getAngleToTeammate ()
double | getTimeSinceLastCarryBall ()
double | getTimeSinceLastKick ()
bool | getAnotherPlayerIsInReadyState ()
| A function for the symbol "another-player-is-in-ready-state".
bool | getAnotherPlayerIsInInitialState ()
| A function for the symbol "another-player-is-in-initial-state".
bool | getAnotherTeammateIsPerformingAKick ()
| A function for the symbol "another-teammate-is-performing-a-kick".
bool | getAnotherTeammateIsPerformingAPass ()
| A function for the symbol "another-teammate-is-performing-a-pass".
bool | getTheStrikerIsPlayingNearTheOpponentGoal ()
| A function for the symbol "the-striker-is-playing-near-the-opponent-goal".
bool | getTheStrikerIsNotPlayingNearTheOpponentGoal ()
| A function for the symbol "the-striker-is-not-playing-near-the-opponent-goal".
bool | getTheStrikerIsPlayingNearTheOwnGoal ()
| A function for the symbol "the-striker-is-playing-near-the-own-goal".
bool | getTheStrikerIsNotPlayingNearTheOwnGoal ()
| A function for the symbol "the-striker-is-not-playing-near-the-own-goal".
double | getGoalieMaxPositionSpeed ()
| A function for the symbol "goalie-max-position-speed".
double | getSearchBallX ()
| A function for the symbol "search-ball.x".
double | angleToTeammateIndex
bool | ballIsHandledAtTheMoment
| Whether the ball is handled at the moment.
bool | goingToInterceptionPoint
| Whether the robot is running to the interception point with the ball.
unsigned long | timeSinceLastCarryBall
| Represents the time since last successfully ball carrying.
unsigned long | timeSinceLastKick
| Represents the time since last successfull kick.
## Public Types
enum | BehaviorTimeState { dontSave, saveTime, resetTime }
enum | { doProfiling, dontDoProfiling }
| Output-Symbols for Profiler. More...
enum | { writeProfiles, writeCompleteProfiles, dontWriteProfiles }
## Public Member Functions
| GT2005StrategySymbols (BehaviorControlInterfaces &interfaces)
void | registerSymbols (Xabsl2Engine &engine)
| registers the symbols at an engine
void | update ()
| updates the symbols
void | estimateTimeToReachBall ()
| computes the estimated time to reach the ball
void | computeRole ()
| computes the current role
## Public Attributes
BehaviorTimeState | behaviorTimeCarryBallState
BehaviorTimeState | behaviorTimeKickState
double | estimatedTimeToReachBall
| current estimated time to reach the ball
BehaviorTeamMessage::DynamicRole | role
| current role
enum GT2005StrategySymbols:: { ... } | doProfile
| Output-Symbols for Profiler.
enum GT2005StrategySymbols:: { ... } | writeProfile
## Private Attributes
bool | timeSinceLastCarryBallSaved
bool | timeSinceLastKickSaved
BehaviorTeamMessage::DynamicRole | roleLastFrame
unsigned long | timeStampSinceRoleChange

## Detailed Description

The Xabsl2 symbols that are defined in "strategy-symbols.xml".

Author:
  Martin Lötzsch

Definition at line 22 of file GT2005StrategySymbols.h.

## Member Enumeration Documentation

enum GT2005StrategySymbols::BehaviorTimeState

  | Enumeration values:
  dontSave |
  saveTime |
  resetTime |
Definition at line 31 of file GT2005StrategySymbols.h.

anonymous enum

  | Output-Symbols for Profiler. Enumeration values:
  doProfiling |
  dontDoProfiling |
Definition at line 123 of file GT2005StrategySymbols.h.

anonymous enum

  | Enumeration values:
  writeProfiles |
  writeCompleteProfiles |
  dontWriteProfiles |
Definition at line 124 of file GT2005StrategySymbols.h.

## Constructor & Destructor Documentation

GT2005StrategySymbols::GT2005StrategySymbols | ( | BehaviorControlInterfaces & | interfaces | ) |

| Definition at line 13 of file GT2005StrategySymbols.cpp. References behaviorTimeCarryBallState, behaviorTimeKickState, dontSave, timeSinceLastCarryBall, timeSinceLastCarryBallSaved, timeSinceLastKick, and timeSinceLastKickSaved.

## Member Function Documentation

void GT2005StrategySymbols::registerSymbols | ( | Xabsl2Engine & | engine | ) |

| registers the symbols at an engine Definition at line 30 of file GT2005StrategySymbols.cpp. References angleToTeammateIndex, ballIsHandledAtTheMoment, BallHandling::behaviorBallState, behaviorTimeCarryBallState, behaviorTimeKickState, dontSave, BehaviorTeamMessage::gameState, getAngleToTeammate(), getAnotherPlayerIsInInitialState(), getAnotherPlayerIsInReadyState(), getAnotherTeammateIsPerformingAKick(), getAnotherTeammateIsPerformingAPass(), getGoalieMaxPositionSpeed(), getRobotNumber(), getSearchBallX(), getTheStrikerIsNotPlayingNearTheOpponentGoal(), getTheStrikerIsNotPlayingNearTheOwnGoal(), getTheStrikerIsPlayingNearTheOpponentGoal(), getTheStrikerIsPlayingNearTheOwnGoal(), getTimeSinceLastCarryBall(), getTimeSinceLastKick(), goingToInterceptionPoint, BehaviorTeamMessage::message, Xabsl2Symbols::registerBooleanInputSymbol(), Xabsl2Symbols::registerDecimalInputFunction(), Xabsl2Symbols::registerDecimalInputFunctionParameter(), Xabsl2Symbols::registerDecimalInputSymbol(), Xabsl2Symbols::registerEnumeratedInputSymbol(), Xabsl2Symbols::registerEnumeratedInputSymbolEnumElement(), Xabsl2Symbols::registerEnumeratedOutputSymbol(), Xabsl2Symbols::registerEnumeratedOutputSymbolEnumElement(), resetTime, and saveTime. Referenced by GT2005BehaviorControl::registerSymbolsAndBasicBehaviors().

Here is the call graph for this function:

void GT2005StrategySymbols::update | ( |  | ) |

| updates the symbols Definition at line 144 of file GT2005StrategySymbols.cpp. References ballIsHandledAtTheMoment, BallHandling::behaviorBallState, behaviorTimeCarryBallState, behaviorTimeKickState, computeRole(), DEBUG_RESPONSE, dontSave, BehaviorTeamMessage::dynamicRole, BehaviorTeamMessage::estimatedTimeToReachBall, estimateTimeToReachBall(), SystemCall::getCurrentSystemTime(), SystemCall::getTimeSince(), goingToInterceptionPoint, idText, MODIFY, NCIRCLE, NDECLARE_DEBUGDRAWING, OUTPUT, resetTime, roleLastFrame, saveTime, timeSinceLastCarryBall, timeSinceLastCarryBallSaved, timeSinceLastKick, timeSinceLastKickSaved, BehaviorTeamMessage::timeSinceRoleChange, timeStampSinceRoleChange, Pose2D::translation, Vector2< double >::x, and Vector2< double >::y. Referenced by GT2005BehaviorControl::execute().

Here is the call graph for this function:

void GT2005StrategySymbols::estimateTimeToReachBall | ( |  | ) |

| computes the estimated time to reach the ball Definition at line 431 of file GT2005StrategySymbols.cpp. References BallHandling::behaviorBallState, DEBUG_RESPONSE, BallModel::getKnownPosition(), getPlayer(), Player::getPlayerNumber(), BallModel::getTimeSinceLastKnown(), BallState::positionField, and BallModel::seen. Referenced by update().

Here is the call graph for this function:

void GT2005StrategySymbols::computeRole | ( |  | ) |

| computes the current role Definition at line 219 of file GT2005StrategySymbols.cpp. References BallState::ballInFrontOfOpponentGoal, DEBUG_RESPONSE_NOT, FieldDimensions::distanceToOpponentPenaltyArea(), BallModel::getKnownBallState(), getPlayer(), Player::getPlayerNumber(), SystemCall::getTimeSince(), BallState::positionField, BallModel::seen, SeenBallState::timeWhenLastSeen, Pose2D::translation, and Vector2< double >::x. Referenced by update().

Here is the call graph for this function:

double GT2005StrategySymbols::getRobotNumber | ( |  | ) | `[inline]`

| Definition at line 65 of file GT2005StrategySymbols.h. References getPlayer(), and Player::getPlayerNumber(). Referenced by registerSymbols().

Here is the call graph for this function:

double GT2005StrategySymbols::getAngleToTeammate | ( |  | ) |

| the Parameter "robot-pose.get-angle-to-teammate.index" for the decimal input function "robot-pose.get-angle-to-teammate" Definition at line 492 of file GT2005StrategySymbols.cpp. References angleToTeammateIndex, PlayerPoseCollection::getOwnPlayerPose(), PlayerPose::getPose(), PlayerPoseCollection::numberOfOwnPlayers, toDegrees(), and Pose2D::translation. Referenced by registerSymbols().

Here is the call graph for this function:

double GT2005StrategySymbols::getTimeSinceLastCarryBall | ( |  | ) |

| calculates the value for the input function get-time-since-kick Definition at line 509 of file GT2005StrategySymbols.cpp. References SystemCall::getTimeSince(), and timeSinceLastCarryBall. Referenced by registerSymbols().

Here is the call graph for this function:

double GT2005StrategySymbols::getTimeSinceLastKick | ( |  | ) |

| Definition at line 516 of file GT2005StrategySymbols.cpp. References SystemCall::getTimeSince(), and timeSinceLastKick. Referenced by registerSymbols().

Here is the call graph for this function:

bool GT2005StrategySymbols::getAnotherPlayerIsInReadyState | ( |  | ) |

| A function for the symbol "another-player-is-in-ready-state". Definition at line 523 of file GT2005StrategySymbols.cpp. Referenced by registerSymbols().

bool GT2005StrategySymbols::getAnotherPlayerIsInInitialState | ( |  | ) |

| A function for the symbol "another-player-is-in-initial-state". Definition at line 539 of file GT2005StrategySymbols.cpp. Referenced by registerSymbols().

bool GT2005StrategySymbols::getAnotherTeammateIsPerformingAKick | ( |  | ) |

| A function for the symbol "another-teammate-is-performing-a-kick". Definition at line 555 of file GT2005StrategySymbols.cpp. Referenced by registerSymbols().

bool GT2005StrategySymbols::getAnotherTeammateIsPerformingAPass | ( |  | ) |

| A function for the symbol "another-teammate-is-performing-a-pass". Definition at line 571 of file GT2005StrategySymbols.cpp. Referenced by registerSymbols().

bool GT2005StrategySymbols::getTheStrikerIsPlayingNearTheOpponentGoal | ( |  | ) |

| A function for the symbol "the-striker-is-playing-near-the-opponent-goal". Definition at line 587 of file GT2005StrategySymbols.cpp. Referenced by registerSymbols().

bool GT2005StrategySymbols::getTheStrikerIsNotPlayingNearTheOpponentGoal | ( |  | ) |

| A function for the symbol "the-striker-is-not-playing-near-the-opponent-goal". Definition at line 603 of file GT2005StrategySymbols.cpp. Referenced by registerSymbols().

bool GT2005StrategySymbols::getTheStrikerIsPlayingNearTheOwnGoal | ( |  | ) |

| A function for the symbol "the-striker-is-playing-near-the-own-goal". Definition at line 619 of file GT2005StrategySymbols.cpp. Referenced by registerSymbols().

bool GT2005StrategySymbols::getTheStrikerIsNotPlayingNearTheOwnGoal | ( |  | ) |

| A function for the symbol "the-striker-is-not-playing-near-the-own-goal". Definition at line 635 of file GT2005StrategySymbols.cpp. Referenced by registerSymbols().

double GT2005StrategySymbols::getGoalieMaxPositionSpeed | ( |  | ) |

| A function for the symbol "goalie-max-position-speed". Definition at line 413 of file GT2005StrategySymbols.cpp. References Geometry::distanceTo(), RobotPose::getPose(), max, min, BallState::positionField, and BallModel::seen. Referenced by registerSymbols().

Here is the call graph for this function:

double GT2005StrategySymbols::getSearchBallX | ( |  | ) |

| A function for the symbol "search-ball.x". Definition at line 651 of file GT2005StrategySymbols.cpp. References getPlayer(), and Player::getPlayerNumber(). Referenced by registerSymbols().

Here is the call graph for this function:

## Member Data Documentation

BehaviorTimeState GT2005StrategySymbols::behaviorTimeCarryBallState

| Definition at line 38 of file GT2005StrategySymbols.h. Referenced by GT2005StrategySymbols(), registerSymbols(), and update().

BehaviorTimeState GT2005StrategySymbols::behaviorTimeKickState

| Definition at line 39 of file GT2005StrategySymbols.h. Referenced by GT2005StrategySymbols(), registerSymbols(), and update().

double GT2005StrategySymbols::estimatedTimeToReachBall

| current estimated time to reach the ball Definition at line 48 of file GT2005StrategySymbols.h.

BehaviorTeamMessage::DynamicRole GT2005StrategySymbols::role

| current role Definition at line 54 of file GT2005StrategySymbols.h. Referenced by GT2005BehaviorControl::postExecute().

double GT2005StrategySymbols::angleToTeammateIndex

| calculates the value for the input function get-time-since-last-carry-ball Definition at line 72 of file GT2005StrategySymbols.h. Referenced by getAngleToTeammate(), and registerSymbols().

bool GT2005StrategySymbols::ballIsHandledAtTheMoment

| Whether the ball is handled at the moment. Definition at line 109 of file GT2005StrategySymbols.h. Referenced by registerSymbols(), and update().

bool GT2005StrategySymbols::goingToInterceptionPoint

| Whether the robot is running to the interception point with the ball. Definition at line 112 of file GT2005StrategySymbols.h. Referenced by registerSymbols(), and update().

unsigned long GT2005StrategySymbols::timeSinceLastCarryBall

| Represents the time since last successfully ball carrying. Definition at line 115 of file GT2005StrategySymbols.h. Referenced by getTimeSinceLastCarryBall(), GT2005StrategySymbols(), and update().

unsigned long GT2005StrategySymbols::timeSinceLastKick

| Represents the time since last successfull kick. Definition at line 118 of file GT2005StrategySymbols.h. Referenced by getTimeSinceLastKick(), GT2005StrategySymbols(), and update().

enum { ... } GT2005StrategySymbols::doProfile

| Output-Symbols for Profiler.

enum { ... } GT2005StrategySymbols::writeProfile

bool GT2005StrategySymbols::timeSinceLastCarryBallSaved`[private]`

| Definition at line 127 of file GT2005StrategySymbols.h. Referenced by GT2005StrategySymbols(), and update().

bool GT2005StrategySymbols::timeSinceLastKickSaved`[private]`

| Definition at line 128 of file GT2005StrategySymbols.h. Referenced by GT2005StrategySymbols(), and update().

BehaviorTeamMessage::DynamicRole GT2005StrategySymbols::roleLastFrame`[private]`

| Definition at line 130 of file GT2005StrategySymbols.h. Referenced by update().

unsigned long GT2005StrategySymbols::timeStampSinceRoleChange`[private]`

| Definition at line 131 of file GT2005StrategySymbols.h. Referenced by update().

The documentation for this class was generated from the following files:

- Modules/BehaviorControl/GT2005BehaviorControl/GT2005Symbols/GT2005StrategySymbols.h
- Modules/BehaviorControl/GT2005BehaviorControl/GT2005Symbols/GT2005StrategySymbols.cpp